apiVersion: v1
kind: Service
metadata:
{% if (is_exporter | default(False) and svc_metrics_path | default(False)) or (k8s_flavor == 'openshift' and (svc_tolerate_unready | default(False) or (svc_gen_keypair | default(False) not in [ False, 'false', 'False' ]))) or ((svc_affinity_type | default(False)) == 'ClientIP' and (ingress_flavor | default('nginx')) == 'traefik') %}
  annotations:
{% if is_exporter | default(False) and svc_metrics_path | default(False) %}
    prometheus.io/path: {{ svc_metrics_path }}
{% endif %}
{% if svc_tolerate_unready | default(False) and k8s_flavor == 'openshift' %}
    service.alpha.kubernetes.io/tolerate-unready-endpoints: "true"
{% endif %}
{% if (svc_gen_keypair | default(False) not in [ False, 'false', 'False' ]) and k8s_flavor == 'openshift' %}
    service.{{ 'alpha' if (ocp_major in [ '3', 3 ]) else 'beta' }}.openshift.io/serving-cert-secret-name: {{ svc_gen_keypair }}
{% endif %}
{% if (svc_affinity_type | default(False)) == 'ClientIP' and (ingress_flavor | default('nginx')) == 'traefik' %}
    traefik.ingress.kubernetes.io/service.sticky: "true"
{% endif %}
{% endif %}
{% if is_exporter | default(False) %}
  labels:
    {{ prometheus_label | default(prometheus_service_label) }}: {{ prometheus_match }}
  name: exporter-{{ svc_name }}
{% else %}
  name: {{ svc_name }}
{% endif %}
  namespace: {{ namespace }}
spec:
{% if externalip | default(False) %}
  externalIPs:
  - {{ externalip }}
{% endif %}
  ports:
{% for port in ports %}
{% set realport = (port | string).split(':')[0] %}
{% set proto = ((port | string).split(':')[1]) | default('TCP') %}
{% if is_exporter | default(False) %}
  - name: exporter-{{ realport }}
{% else %}
  - name: {{ proto | lower }}-{{ realport }}
{% endif %}
    port: {{ realport }}
    protocol: {{ proto }}
{% if svc_target_add | default(False) %}
    targetPort: {{ ( svc_target_add | int ) + ( realport | int ) }}
{% else %}
    targetPort: {{ realport }}
{% endif %}
{% if (svc_type | default('ClusterIP')) == 'NodePort' and (svc_nodeport_add | default(False)) %}
    nodePort: {{ ( svc_nodeport_add | int ) + ( realport | int ) }}
{% endif %}
{% endfor %}
{% if svc_tolerate_unready | default(False) and k8s_flavor == 'kubernetes' %}
  publishNotReadyAddresses: true
{% endif %}
{% if not (svc_manual_endpoints | default(False)) %}
  selector:
{% if svc_selector_key | default(False) %}
    {{ svc_selector_key }}: {{ svc_selector | default(svc_name) }}
{% else %}
    name: {{ svc_selector | default(svc_name) }}
{% endif %}
{% endif %}
{% if svc_clusterip | default(False) %}
  clusterIP: {{ svc_clusterip }}
{% else %}
  type: {{ svc_type | default('ClusterIP') }}
{% endif %}
{% if (svc_affinity_type | default(False)) == 'ClientIP' %}
  sessionAffinity: ClientIP
  sessionAffinityConfig:
    clientIP:
      timeoutSeconds: {{ svc_affinity_timeout | default(3600) }}
{% endif %}
{% if svc_topology_affinity | default(False) and not (externalip | default(False)) %}
  topologyKeys:
{% if svc_topology_affinity == 'host' %}
    - {{ service_topology_node_label }}
{% elif svc_topology_affinity == 'region' %}
    - {{ service_topology_region_label }}
{% elif svc_topology_affinity == 'zone' %}
    - {{ service_topology_zone_label }}
{% else  %}
    - {{ service_topology_node_label }}
    - {{ service_topology_region_label }}
    - {{ service_topology_zone_label }}
{% endif %}
{% if not (svc_topology_exclusive_affinity | default(False)) %}
    - "*"
{% endif %}
{% endif %}
